This file is part of the Basilic system
Copyright (C) 2004  Gilles Debunne (Gilles.Debunne@imag.fr)
Version 1.5.14, packaged on May 2, 2007.

http://artis.imag.fr/Software/Basilic

Basilic  is  free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published
by the Free Software Foundation; either version 2 of the License,
or (at your option) any later version.

Basilic  is  distributed  in the hope that it will be useful, but
WITHOUT  ANY  WARRANTY ; without  even  the  implied  warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License for more details.

You should have received a copy of the GNU General Public License
along with Basilic; if not, write to the Free Software Foundation
Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
<html>
<head>
 <meta http-equiv='pragma' content='no-cache'>
 <meta http-equiv='expires' content='0'>
 <link rel="stylesheet" href="/@@CSSPath@@/backoffice.css" type="text/css" />
</head>

<body>

<h1>Results of your command</h1>

<?php

require_once("../utils.php");
intranetSqlConnect();

function debug($message)
{
  echo "<span style='color:orange;font-weight:bold'>Debug &raquo;</span> $message<br/>\n";
}

if (isset($_GET))
{
  if (!empty($_GET["act"])) $action=$_GET["act"];
  if (!empty($_GET["id"])) $id=$_GET["id"];
}

if (empty($action)) error("No action given");
if ($action!="add" && empty($id)) error("No id given");

function createDirectory($str)
{
  debug("Creating directory $str...");
  umask(0);
  mkdir($str, 0777);
  debug("Testing directory $str exists");
  if (!is_dir($str))
    error("Error : directory $str could not be created.");
}

function getNextAvailableBibTex($bibTex)
{
  $newBibTex = $bibTex;
  $i = ord("a");
  while (is_dir("@@DocumentRoot@@/@@PublicationsPath@@/$_GET[year]/$newBibTex"))
    {
      $newBibTex = $bibTex.chr($i);
      $i++;
    }
  debug("getNextAvailableBibTex : $newBibTex");
  return $newBibTex;
}

function computeBibTexKey()
{
  global $id;
  $authorsIds = split(",", $_GET["authorList"]);
  if (count($authorsIds)==0)
    error("Author list is empty for publication $id");
  foreach ($authorsIds as $authorId)
    {
      $result = sqlQuery("SELECT last FROM authors WHERE id=$authorId");
      if (!$result)
	error("Unable to get name from author id $authorId. id=$id");
      $row=mysql_fetch_array($result);
      $last=$row["last"];
      if (count($authorsIds)==1)
	$key=strtoupper(substr($last,0,1)).strtolower(substr($last,1,2));
      else
	$key=$key.strtoupper(substr($last,0,1));
    }
  $key=strtr($key, "C", "aaaaAAAAeeeeEEEEiiiiIIIIooooOOOOuuuuUUUUcC");
  $key=$key.substr($_GET["year"],2,2);
  debug("bibTex=<b>$key</b>");
  return $key;
}

function checkYearDirExists()
{
  $year = $_GET["year"];
  $mdir = "@@PublicationsPath@@/$year";
  $dir  = "@@DocumentRoot@@/$mdir";
  if (!is_dir($dir))
    {
      umask(0);
      if (mkdir("$dir", 0755))
	debug("Creating year directory $mdir");
      else
	error("Unable to create directory $mdir - Aborting");

      $file="$dir/index.php";
      debug("Creating $file");
      $f=fopen($file,"w");
      fwrite($f, "<"."?php \$year=$year; include(\"../index.php\"); ?".">");
      fclose($f);
      chmod($file, 0644);
    }
  
  // Check everything has been created
  if (!is_dir("$dir"))
    error("Directory $mdir does not exist");
  if (!is_file("$dir/index.php"))
    error("File $mdir/index.php does not exist");
}

function cmd($cmd)
{
  debug("exec cmd $cmd");
  exec($cmd, $output, $val);
  if ($val != 0)
    error("Error during command $cmd : return value is $val");
}

function LaTeXToIso($str)
{
  $search = array("\\\\\\'e","\\\\`e","\\\\^e","\\\\\\\"e","\\\\\\'a","\\\\`a","\\\\^a","\\\\\\\"a","\\\\\\'i","\\\\`i","\\\\^i","\\\\\\\"i",
		  "\\\\\\'o","\\\\`o","\\\\^o","\\\\\\\"o","\\\\\\'u","\\\\`u","\\\\^u","\\\\\\\"u","\\\\cc","\\\\cC","\\\\~n","\\\\~N","\\\\&");
  $replace = array("","","","","","","","","","","","",
		   "","","","","","","","","","","","","&");
  return ereg_replace("^ *", "", str_replace($search, $replace, $str));
}

$fields=array("title","year","address","booktitle","chapter","edition","editor","howpublished","institution","journal","keywords","month","note","number","optkey","organization","pages","publisher","school","series","type","volume");

echo "<div class='information'>\n";

if ($action=="add")
{
  checkYearDirExists();

  // Compute BibTex key, adding extra letters if needed
  $year = $_GET["year"];
  $bibTex = computeBibTexKey();
  $bibTex = getNextAvailableBibTex($bibTex);

  // Set publication data
  $query = "INSERT into publis (entry, bibTex";
  foreach($fields as $field)
    if (isset($_GET["$field"]))
      $query .= ", $field";
  $query .= ") VALUES ('$_GET[entry]', '$bibTex'";
  foreach($fields as $field)
    if (isset($_GET["$field"]))
      $query .= ", '".LaTeXToIso($_GET["$field"])."'";
  $query .= ")";
  debug($query);
  sqlQuery($query);

  $id=mysql_insert_id();

  // Link to authors
  $authorsIds = explode(",", $_GET["authorList"]);
  $rank = 1;
  foreach ($authorsIds as $authorId)
    {
      debug("INSERT INTO publiauthors (idAuthor, idPubli, rank) VALUES ($authorId, $id, $rank)");
      sqlQuery("INSERT INTO publiauthors (idAuthor, idPubli, rank) VALUES ($authorId, $id, $rank)");
      $rank++;
    }

  $publiPath="@@DocumentRoot@@/@@PublicationsPath@@/$year/$bibTex";
  createDirectory($publiPath);

  $file="$publiPath/index.php";
  $f=fopen($file,"w");
  fwrite($f, "<"."?php \$id=$id; include(\"../../publi.php\"); ?".">");
  fclose($f);
  chmod($file, 0644);
  if (!is_file($file))
    error("Unable to create $publiPath/$year/$bibTex/index.php");
  else
    debug("$file has been created");
  // debug("&lt;?php \$id=$id; include(\"../../publi.php\"); ?&gt;");

  echo "<p>\nPublication has been added to the database. Its associated directory is <code>@@PublicationsPath@@/$year/$bibTex</code><br/>\n";
  echo "You should now move all associated documents (pdf, ppt, ps, abstract, info, images, movies) in this directory.<br/>\n";
  echo "See the <a href='../usersguide.html' target='_top'>Publication help page</a> for details.</p>\n";

  echo "<p>\n<a href='publi.php?id=$id'>Back to publication edition</a><br/>\n";
  echo "<a href='/@@PublicationsPath@@/$year/$bibTex' target='_top'>See the publication associated page</a></p>\n";
}


else if ($action=="update")
{
  $previousBibTex = $_GET["previousBibTex"];
  $previousYear   = $_GET["previousYear"];
  
  $bibTex = computeBibTexKey();
  if ($bibTex==substr($previousBibTex,0,strlen($bibTex)))
    $bibTex=$previousBibTex; // Add the extra letter (XX00[a,b,c,..]) if it was present

  $year = $_GET["year"];
  if ($year != $previousYear)
    checkYearDirExists();

  if ($bibTex != $previousBibTex)
    {
      // Add possible extra letter if bibTex allready exists
      $bibTex = getNextAvailableBibTex($bibTex);
      debug("BibTex has changed : new is $bibTex");
      
      if ($year == $previousYear)
	{
	  // At least one author has changed : remove previous authors...
	  sqlQuery("DELETE FROM publiauthors WHERE idPubli=$id");
	  // And insert new ones, in right order
	  $authorsIds = explode(",", $_GET["authorList"]);
	  $rank = 1;
	  foreach ($authorsIds as $authorId)
	    {
	      debug("INSERT INTO publiauthors (idAuthor, idPubli, rank) VALUES ($authorId, $id, $rank)");
	      sqlQuery("INSERT INTO publiauthors (idAuthor, idPubli, rank) VALUES ($authorId, $id, $rank)");
	      $rank++;
	    }
	}

      cmd("mv -f @@DocumentRoot@@/@@PublicationsPath@@/$previousYear/$previousBibTex @@DocumentRoot@@/@@PublicationsPath@@/$year/$bibTex");
      echo "BibTex has changed, your publication is now located in the <code>@@PublicationsPath@@/$year/$bibTex</code> directory<br/>\n";
      
      debug ("Publication directory moved to @@PublicationsPath@@/$year/$bibTex");
      if (!is_dir("@@DocumentRoot@@/@@PublicationsPath@@/$year/$bibTex"))
	error("Unable to move directory to $year/$bibTex - Administrator has been warned");
    }

  // Update publication data
  $query = "UPDATE publis SET entry='$_GET[entry]', bibTex='$bibTex'";
  foreach($fields as $field)
    if (isset($_GET["$field"]))
      $query .= ", $field='".LaTeXToIso($_GET[$field])."'";
  
  $query .= " WHERE id=$id";
  debug($query);
  sqlQuery($query);

  echo "<p>\nPublication has been updated.</p>\n";

  echo "<p>\n<a href='publi.php?id=$id'>Back to publication edition</a><br/>\n";
  echo "<a href='/@@PublicationsPath@@/$year/$bibTex' target='_top'>See the publication associated page</a></p>\n";
}


else if ($action=="delete")
{
  // Check Garbage dir exists
  $garbage="/@@PublicationsPath@@/Garbage";
  $garbageDir="@@DocumentRoot@@/$garbage";
  if (!is_dir($garbageDir))
    error("Garbage directory ($garbageDir) does not exists, cannot remove $_GET[previousBibTex]");

  debug("DELETE FROM publis WHERE id=$id");
  sqlQuery("DELETE FROM publis WHERE id=$id");
  debug("DELETE FROM publiauthors WHERE idPubli=$id");
  sqlQuery("DELETE FROM publiauthors WHERE idPubli=$id");
  debug("DELETE FROM publidocs WHERE idPubli=$id");
  sqlQuery("DELETE FROM publidocs WHERE idPubli=$id");
  echo "Publication removed from database<br/>\n";

  // Move previous directory in Garbage/bibtex
  $previousDir="@@DocumentRoot@@/@@PublicationsPath@@/$_GET[previousYear]/$_GET[previousBibTex]";
  cmd("mv -f $previousDir $garbageDir");
  echo "Previous publication directory has been moved in <code>$garbage/$_GET[previousBibTex]</code><br/>\n";
}
else
  error("Internal error : unrecognized action $action.");


echo "</div>\n";
?>

</body>
</html>
