This file is part of the Basilic system
Copyright (C) 2004  Gilles Debunne (Gilles.Debunne@imag.fr)
Version 1.5.14, packaged on May 2, 2007.

http://artis.imag.fr/Software/Basilic

Basilic  is  free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published
by the Free Software Foundation; either version 2 of the License,
or (at your option) any later version.

Basilic  is  distributed  in the hope that it will be useful, but
WITHOUT  ANY  WARRANTY ; without  even  the  implied  warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License for more details.

You should have received a copy of the GNU General Public License
along with Basilic; if not, write to the Free Software Foundation
Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
<?php

// Defines the $lg variable
require("getLanguage.php");

if ($lg=="fr")
{
  // Translate "fr" and these lines into another language if needed.
  $txtIn="en";
  $txtNoResult="Aucun r&eacute;sultat n'a &eacute;t&eacute; trouv&eacute;.";
  $txtCloseName="Noms avec une orthographe proche ";
  $txtDisplayAll="Afficher toute la liste";
}
else
{
  // Default language is english
  $txtIn="in";
  $txtNoResult="No publications were found.";
  $txtCloseName="Possible name misspellings";
  $txtDisplayAll="Display the complete list";
}

if (!isset($author))    $author    = $_GET["author"];
if (!isset($display))   $display   = $_GET["display"];
if (!isset($full))      $full 	   = $_GET["full"];
if (!isset($idAuthor))  $idAuthor  = str_replace(array("[[:alpha]]", "/"), "", $_GET["idAuthor"]);
if (!empty($idAuthor) && (!is_numeric($idAuthor)))
   unset($idAuthor);
if (!isset($nbPerPage)) $nbPerPage = $_GET["nbPerPage"];
if (!isset($pg))        $pg 	   = $_GET["pg"];
if (!isset($title))     $title 	   = $_GET["title"];
if (!isset($year))      $year 	   = $_GET["year"];

if (empty($pg)) $pg = 1;
if (empty($nbPerPage)) $nbPerPage = 20;

$option["author"]    = $author;
$option["display"]   = $display;
$option["full"]      = $full;
$option["idAuthor"]  = $idAuthor;
$option["nbPerPage"] = $nbPerPage;
$option["pg"]        = $pg;
$option["title"]     = $title;
$option["year"]      = $year;

require("utils.php");
sqlConnect();

// Search for author name from idAuthor
if (!empty($idAuthor))
{
  $resultIdAuthor = sqlQuery("SELECT first, last FROM authors WHERE id=$idAuthor");
  $rowIdAuthor=mysql_fetch_array($resultIdAuthor);
  $author=$rowIdAuthor["last"];
}

$labName="@@LabName@@";
if (empty($author))
  $titleName=$labName;
else
  if ($lg=="fr")
    $titleName="de $author chez $labName";
  else
    $titleName="$author's";

if ($lg=="fr")
  if ($display=="gallery")
    $title="Galerie d'images $titleName";
else
    $title="Publications $titleName";
  else
  if ($display=="gallery")
    $title="$titleName image gallery";
  else
   {
     $title="$titleName publications";
     if (!empty($author)) $title.=" with $labName";
   }

if (!empty($year) && ($year != -1))
  $title .= " $txtIn $year";
     
$css="/@@CSSPath@@/listpubli.css";
include("header.php");
echo "<h1>$title</h1>\n\n";
unset($title); // interfers with form parameters

$title=$_GET["title"];

require("publiUtils.php");

$result = bibQueryResults($option);
$nbPublis=mysql_num_rows($result);

// Search engine
require("search.php");

function pageIndex()
{
  global $nbPublis;
  global $nbPerPage;
  global $pg;
  global $txtDisplayAll;

  $res = "<div class='pageMenu'>\n";
  $publication = ($nbPublis>1)?"publications":"publication";

  if ($nbPublis>$nbPerPage)
    {
      if (empty($_SERVER["QUERY_STRING"]))
	$param="?pg=";
      else
	{
	  $param=ereg_replace("&pg=[0-9]*", "", "&".$_SERVER["QUERY_STRING"]);
	  $param=ereg_replace("&[a-zA-Z]*=&", "&", $param);
	  $param=ereg_replace("&[xy]=0", "", $param);
	  if (empty($param))
	    $param="?pg=";
	  else
	    $param=ereg_replace("^&", "?", $param)."&pg=";
	}

      $href="  <a href='$_SERVER[SCRIPT_NAME]$param";

      if ($pg==-1)
	$res .= " <div class='displayAll'>\n$nbPublis $publication\n </div>\n";
      else
	$res .= " <div class='displayAll'>\n$href"."-1'>$txtDisplayAll</a> ($nbPublis $publication)\n </div>\n";

      $res .= " <div class='pageIndex'>\n";

      if ($pg>1)
	$res .= $href.($pg-1)."'>&laquo;</a> &nbsp;\n";

      $imin=max(1, $pg-5);
      $imax=min($pg+14,floor(($nbPublis/$nbPerPage)+1));
      for ($i=$imin; $i<=$imax; $i++)
	{
	  if ($i==$pg)
	    $res.="  <b>$i</b>";
	  else
	    $res.=$href.$i."'>$i</a>";
	  $res .= " &nbsp;\n";
	}

      if (($pg!=-1) && ($pg<$imax))
	$res .= "$href".($pg+1)."'>&nbsp; &raquo;</a>\n";

      $res .= " </div>\n";
    }
  else
    $res .= " <div class='displayAll'>\n  $nbPublis $publication\n </div>\n";

  $res .= " <div>&nbsp;</div>\n";
  $res .= "</div>\n\n";
  return $res;
}

$pgIndex=pageIndex();

echo $pgIndex;

// If no results were found
if ($nbPublis==0)
{
  echo "<div class='noresult'>\n";
  echo "  <h2>$txtNoResult</h2>\n";

  // Possible wrong author name spelling
  if (!empty($author))
    {
      $param = "";
      if (!empty($title))   $param .= "&amp;title=$title";
      if (!empty($year))    $param .= "&amp;year=$year";
      if (!empty($display)) $param .= "&amp;display=$display";
      if (!empty($full))    $param .= "&amp;full=$full";
      if (!empty($pg))      $param .= "&amp;pg=$pg";

      // Find names like author name
      $resultLike = sqlQuery("SELECT DISTINCT id,last,first FROM authors WHERE last LIKE '%$author%' AND last!='$author' ORDER BY last ASC");
      while ($resultLike && $row=mysql_fetch_array($resultLike))
	{
	  $name=$row["first"]." ".$row["last"];
	  $possibleNames .= "<li><a href='index.php?idAuthor=$row[id]$param'>&raquo; $name</a></li>\n";
	  if (!empty($list))
	    $list .= ",".$row["id"];
	  else
	    $list = $row["id"];
	}

      // And names that soundex like author name
      if (!empty($list))
	$condition = "AND id NOT IN ($list)";

      $resultSound = sqlQuery("SELECT DISTINCT id,last,first FROM authors WHERE SOUNDEX(last)=SOUNDEX('$author') $condition AND last!='$author' ORDER BY last ASC");
      $nbSoundex=mysql_num_rows($resultSound);
      while ($resultSound && $row=mysql_fetch_array($resultSound))
	{
	  $name=$row["first"]." ".$row["last"];
	  $possibleNames .= "<li><a href='index.php?idAuthor=$row[id]$param'>&raquo; $name</a></li>\n";
	}

      if (!empty($possibleNames))
	{
	  echo "  $txtCloseName:<br />\n";
	  echo "  <ul style='list-style-type: none'>\n$possibleNames</ul>\n";
	}
    }
  echo "</div>\n";
}

displayResults($result, $option);
echo $pgIndex;

// echo "<script type='text/javascript'>\n";
// echo "  document.forms[0].elements[0].focus();\n";
// echo "</script>\n\n";

include("footer.php");
?>
