This file is part of the Basilic system
Copyright (C) 2004  Gilles Debunne (Gilles.Debunne@imag.fr)
Version 1.5.14, packaged on May 2, 2007.

http://artis.imag.fr/Software/Basilic

Basilic  is  free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published
by the Free Software Foundation; either version 2 of the License,
or (at your option) any later version.

Basilic  is  distributed  in the hope that it will be useful, but
WITHOUT  ANY  WARRANTY ; without  even  the  implied  warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License for more details.

You should have received a copy of the GNU General Public License
along with Basilic; if not, write to the Free Software Foundation
Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
<?php

require("getLanguage.php");

if ($lg == "fr")
{
  // Translate "fr" and this into another language if needed.
  $txtDocs="Images et films";
  $txtSeeAlso="Voir aussi";
  $txtBibtex="R&eacute;f&eacute;rences BibTex";
  $txtOtherPubli="Autres publications dans la base";
  $txtDownload="T&eacute;l&eacute;charger la publication";
}
else
{
  // English is default language
  $txtDocs="Images and movies";
  $txtSeeAlso="See also";
  $txtBibtex="BibTex references";
  $txtOtherPubli="Other publications in the database";
  $txtDownload="Download the publication";
}

# Publication id
if ((isset($_GET)) && (!empty($_GET['id'])))
  $id=$_GET["id"];

if (empty($id))
  die("No publication id given. Aborting");

require("utils.php");

// Possible update of publication associated documents
if ((isset($_GET)) && (!empty($_GET['update'])))
{
  echo "<div class='update'>\n";
  echo " Update of publication documents...<br />\n";
  require("updatePubliDocs.php");
  intranetSqlConnect();
  updatePubliDocs($id);
  mysql_close();
  echo " Done.<br />\n";
  echo "</div>\n\n";
}

sqlConnect();

# Retrieve publication data
$result = sqlQuery("SELECT * FROM publis WHERE publis.id=".$id);
$row = mysql_fetch_array($result) or die("Error : no publication found");

# Title and header
$title="$row[title]";
$css="/@@CSSPath@@/publi.css";
$metaKeywords=$row["keywords"];
$metaDescription=$row["title"];
include("header.php");
require("publiUtils.php");

echo "<h1>$row[title]</h1>\n\n";

echo "<div class='head'>\n";

# Authors
echo "<div class='author'>\n";
printAuthors($id);
echo "\n </div>\n";


# conference, publisher, journal, booktitle, etc
echo "<div class='conf'>\n  ";
printConference($row);
echo " </div>\n";

$year = $row["year"];
$bibtex = $row["bibTex"];
$publiDir="$year/$bibtex";
$path="/@@PublicationsPath@@/$publiDir";
$readFilePath="@@DocumentRoot@@/$path";

# Associated documents.
$dresult = sqlQuery("SELECT id,type,source,size,sizeX,sizeY FROM docs,publidocs where docs.id=publidocs.idDoc AND publidocs.idPubli=$id ORDER BY type ASC,source ASC");
while ($dresult && $drow=mysql_fetch_array($dresult))
{
  $type = $drow["type"];
  $src  = $drow["source"];

  $size = $drow["size"];
  if ($size>1000000)
    $sizeText="[".(floor(1*$size/100000)/10)."Mo]";
  else
    $sizeText="[".floor(1*$size/1000)."Ko]";

  if ($type=="PDF") $docs.="   <a href='$src'><img src='/@@ImagesPath@@/pdf.png' alt='$src $sizeText'/></a> &nbsp;\n";
  if ($type=="PPT") $docs.="   <a href='$src'><img src='/@@ImagesPath@@/ppt.png' alt='$src $sizeText'/></a> &nbsp;\n";
  if ($type=="PS")  $docs.="   <a href='$src'><img src='/@@ImagesPath@@/ps.png' alt='$src $sizeText'/></a> &nbsp;\n";

  if (($type=="IMG") || ($type=="MOV"))
    {
      $ratio=1.0*$drow["sizeX"]/$drow["sizeY"];
      $h=60.0;
      $w=$h*$ratio;
      $pt=13;
      if ($w>80)
	{
	  $w=80;
	  $h=$w/$ratio;
	  $pt=13 + (60-$h)/2.0;
	}

      if ($type=="MOV")
	$class=" movie";

      $w=floor($w);
      $h=floor($h);
      $pt=floor($pt)."px";

     $imgMovies .= "  <div class='thumb$class'><div style='padding-top:$pt'><a href='$path/$src'>\n";
     $imgMovies .= "  <img src='$path/.thumbs/$src.jpg' width='$w' height='$h' alt='$src $sizeText'/></a></div></div>\n";
    }

  if ($type=="INFO")
    {
    if (empty($info))
      $info=$src; // choose first info file
    else
      if (strstr($src,".$lg.html"))
	$info=$src; // replace if adequate language is found
    }
  
  if ($type=="ABS")
    if (empty($abstract))
      $abstract=$src; // chose first abstract
    else
      if (strstr($src,".$lg.html"))
	$abstract=$src; // replace if adequate language is found
}

# Associated documents : pdf, ps and ppt first
if (!empty($docs))
{
  echo "<div class='pdfps'>\n";
  echo "  $txtDownload : \n$docs";
  echo " </div>\n";
}

echo "</div>\n\n"; // head

# Abstract
if (!empty($abstract))
{
  echo "<div class='abstract'>\n";
  readfile("$readFilePath/$abstract");
  echo "\n</div>\n\n";
}

# Images and movies
if (!empty($imgMovies))
{
  echo "<h2>$txtDocs</h2>\n";
  echo "<div class='imgMovies'>\n";
  echo "$imgMovies";
  echo "</div>\n";
  echo "<div class='endthumbs'>&nbsp;</div>\n\n";
}

# See also
if (!empty($info))
{
  echo "<h2>$txtSeeAlso</h2>\n";
  echo "<div class='seeAlso'>\n";
  readfile("$readFilePath/$info");
  echo "</div>\n\n";
}

# BibTex
echo "<h2>$txtBibtex</h2>\n";
printBibTex($row);


# Other publication by the same authors
$aresult = sqlQuery("SELECT * FROM authors,publiauthors where authors.id=publiauthors.idAuthor AND publiauthors.idPubli=$id ORDER BY rank ASC");
while ($aresult && $arow=mysql_fetch_array($aresult))
{
  $aid=$arow["id"];
  $nresult = sqlQuery("SELECT COUNT(*) as nbpubli FROM publiauthors WHERE idAuthor=$aid");
  $nrow=mysql_fetch_array($nresult);
  $nb=$nrow["nbpubli"];
  if ($nb>1)
    $otherPubli .= " <a href='/@@PublicationsPath@@/index.php?idAuthor=$arow[id]'>&raquo; $arow[first] $arow[last]</a><br />\n";
}

if (!empty($otherPubli))
{
  echo "<h2>$txtOtherPubli</h2>\n";
  echo "<div class='otherPubli'>\n";
  echo "$otherPubli";
  echo "</div>\n\n";
}

# Edit and update buttons
if ($local)
{
  echo "<div align='right'>\n";
  echo "  <a href='?update=1'><img src='/@@ImagesPath@@/updatePubli.png'/></a>&nbsp;\n";
  echo "  <a href='/@@BasilicIntranetPath@@/Publications/publi.php?id=$id'><img src='/@@ImagesPath@@/editPubli.png'/></a>\n";
  echo "</div>\n\n";
}

include("footer.php");
?>
