This file is part of the Basilic system
Copyright (C) 2004  Gilles Debunne (Gilles.Debunne@imag.fr)
Version 1.5.14, packaged on May 2, 2007.

http://artis.imag.fr/Software/Basilic

Basilic  is  free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published
by the Free Software Foundation; either version 2 of the License,
or (at your option) any later version.

Basilic  is  distributed  in the hope that it will be useful, but
WITHOUT  ANY  WARRANTY ; without  even  the  implied  warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License for more details.

You should have received a copy of the GNU General Public License
along with Basilic; if not, write to the Free Software Foundation
Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
<?php

require_once("utils.php");

function sourceString($row)
{
  return "type='".$row["type"]."', source='".$row["source"]."'";
}

function sizeString($row)
{
  return "size='".$row["size"]."', sizeX='".$row["sizeX"]."', sizeY='".$row["sizeY"]."'";
}

function updatePubliDocs($publiId)
{
  // General configuration options
  $thumbImgGeometry = "80x60";
  $pubPath = "@@PublicationsPath@@";
  $thumbDir=".thumbs";
  
  if ((!is_numeric($publiId)) || (intval($publiId)!=$publiId))
    error("Invalid publication id ($publiId) - Aborting");

  // Get all documents associated to this publication
  $result = sqlQuery("SELECT * FROM docs, publidocs WHERE publidocs.idPubli=$publiId AND publidocs.idDoc=docs.id");  
  $docInDataBase = array();
  $docSize = array();
  while ($result && $row=mysql_fetch_array($result))
    {
      $docInDataBase[$row["id"]]=sourceString($row);
      $docSize[$row["id"]]=sizeString($row);
    }
  
  $result = sqlQuery("SELECT year, bibTex FROM publis WHERE id=$publiId");
  
  if ($result)
    $row=mysql_fetch_array($result);
  else
    error("Unable to retrieve publication data for publi $publiId");

  $msgPath = "$row[year]/$row[bibTex]";
  $publiPath = "@@DocumentRoot@@/$pubPath/$msgPath";
  $msg = "<a href='/$pubPath/$msgPath'>$row[bibTex]</a> &nbsp; ";

  $compressedExtensions[] = "gz";
  $compressedExtensions[] = "bz";
  $compressedExtensions[] = "bz2";
  $compressedExtensions[] = "zip";
  $compressedExtensions[] = "z";

  // Check that thumbnail directory exists
  if (!is_dir($publiPath))
    {
      if (empty($_GET["forceDirCreation"]))
	error("Publication directory $msgPath does not exist.");
      else
	{
	  umask(0);
	  $yearPath = "@@DocumentRoot@@/$pubPath/$row[year]";
	  if (!is_dir($yearPath))
	    {
	      if (mkdir("$yearPath", 0755))
		echo "Creating year directory $row[year]<br/>\n";
	      else
		error("Unable to create year directory $yearPath - Aborting");

	      $file="$yearPath/index.php";
	      echo "Creating index.php in $row[year]<br/>\n";
	      $f=fopen($file,"w");
	      fwrite($f, "<"."?php if (empty(\$_GET[\"year\"])) \$year=$row[year]; include(\"../index.php\"); ?".">");
	      fclose($f);
	      chmod($file, 0644);

	      if (!is_file("$file"))
		error("File index.php could not be created");
	    }
	  mkdir($publiPath, 0777);
	  if (!is_dir($publiPath))
	    error("Error : directory $publiPath could not be created.");
	  else
	    echo ("Directory created for ");

	  $file="$publiPath/index.php";
	  $f=fopen($file,"w");
	  fwrite($f, "<"."?php \$id=$publiId; include(\"../../publi.php\"); ?".">");
	  fclose($f);
	  chmod($file, 0644);
	  if (!is_file($file))
	    error("Unable to create /$msgPath/index.php");
	}
    }
  
  if (!is_dir("$publiPath/$thumbDir"))
    mkdir("$publiPath/$thumbDir") or error("Unable to create $publiPath/$thumbDir directory");
  
  $thumbDirOk = (is_dir("$publiPath/$thumbDir")) && (is_writable("$publiPath/$thumbDir"));
  if (!$thumbDirOk)
    sendMessage("Thumbnail directory $msgPath/$thumbDir is not writeable");
  
  $dir = dir($publiPath);
  while ($file = $dir->read())
    if ($file != "." && $file != ".." && is_file("$publiPath/$file"))
      {
	$entry["source"] = $file;
	$entry["size"] = filesize("$publiPath/$file");
	$entry["sizeX"] = "0";
	$entry["sizeY"] = "0";
	$skipFile = 0;
	
	// Remove compression extensions 
	$extension = explode('.', $file);
      
	$index = count($extension)-1;
	$ext = strtolower($extension[$index]);
      
	while (in_array($ext, $compressedExtensions))
	  {
	    $index--;
	    $ext = strtolower($extension[$index]);
	  }

	switch ($ext)
	  {
	  case "bmp":
	  case "gif":
	  case "jpg":
	  case "jpeg":
	  case "png":
	  case "ppm":
	  case "psd":
	  case "tif":
	  case "tiff":
	  case "xbm":
	  case "xpm":
	    $entry["type"]="IMG";
	    $imgSize = getimagesize("$publiPath/$file");
	    if ($imgSize[0] * $imgSize[1] != 0)
	      {
		// Create thumbnail if needed
		$entry["sizeX"] = $imgSize[0];
		$entry["sizeY"] = $imgSize[1];
		$thumbName = $file.".jpg";

		if ($thumbDirOk && !is_file("$publiPath/$thumbDir/$thumbName") || filemtime("$publiPath/$file") > (filemtime("$publiPath/$thumbDir/$thumbName")))
		  {
		    echo "  $msg : Creating $msgPath/$thumbDir/$thumbName<br />\n";
		    exec("MAGICK_HOME=".getenv("MAGICK_HOME")."; export MAGICK_HOME; convert -geometry $thumbImgGeometry $publiPath/$file $publiPath/$thumbDir/$thumbName", $output, $returnVar);
		    if ($returnVar != 0)
		      {
			echo "Unable to create thumbnail for $msgPath/$file. Administrator has been warned";
			sendMessage("Unable to create thumbnail for $msgPath/$file error=$returnVar");
			break;
		      }
		  }
		// else
		// sendMessage("Thumbnail up to date for ".$msgPath.$file);
	      }
	    else
	      {
		echo "Unable to create thumbnail for $msgPath/$file. Administrator has been warned";
		sendMessage("Unable to determine image size for $msgPath/$file");
		break;
	      }
	    break;

	  case "mpg":
	  case "mpeg":
	  case "avi":
	  case "mp4":
	  case "mov":
	  case "wmv":
	  case "qt":
	    $entry["type"]="MOV";
	    $thumbName = $file.".jpg";
	    if ($thumbDirOk && !is_file("$publiPath/$thumbDir/$thumbName") || filemtime("$publiPath/$file") > (filemtime("$publiPath/$thumbDir/$thumbName")))
	      {
		echo "Thumbnail will soon be created for $msgPath/$file.<br/>\n";
		sendMessage("Thumbnail must be created for $msgPath/$file");
		if (!copy("@@DocumentRoot@@/@@ImagesPath@@/defaultThumb.jpg", "$publiPath/$thumbDir/$thumbName"))
		  sendMessage("Unable to copy default movie thumb for $msgPath/$file");
	      }

	    if (is_file("$publiPath/$thumbDir/$thumbName"))
	      {
		$imgSize = getimagesize("$publiPath/$thumbDir/$thumbName");
		if ($imgSize[0] * $imgSize[1] != 0)
		  {
		    $entry["sizeX"] = $imgSize[0];
		    $entry["sizeY"] = $imgSize[1];
		  }
	      }
	    else
	      {
		sendMessage("Unable to retrieve thumbnail size for $msgPath/$file");
		$entry["sizeX"] = 1;
		$entry["sizeY"] = 1;
	      }
	    break;

	  case "html":
	    if (($file == "abstract.html") || ($file == "abstract.fr.html") || ($file == "abstract.en.html"))
	      $entry["type"]="ABS";
	    else
	      if (($file == "info.html") || ($file == "info.fr.html") || ($file == "info.en.html"))
		$entry["type"]="INFO";
	      else
		$entry["type"]="UNKNOWN";
	    break;
	  
	  case "ps":
	    $entry["type"]="PS";
	    break;
	  
	  case "pdf": 
	    $entry["type"]="PDF";
	    break;
	  
	  case "py":
	  case "pps":
	  case "ppt":
	    $entry["type"]="PPT";
	    break;

	  case "php":
	    if ($file == "index.php")
	      $skipFile=1;
	    break;
	    
	  default:
	    $entry["type"]="UNKNOWN";
	    break;
	  }

	if (!$skipFile)
	  {
	    if ($entry["type"] == "UNKNOWN")
	      {
		sendMessage("Unrecognized document format for file $publiPath/$file");
		echo "Unrecognized document format : $msgPath/$file<br/>\n";
	      }
	    else
	      {
		$alreadyPresent = array_search(sourceString($entry), $docInDataBase);

		if ($alreadyPresent)
		  {
		    // echo "DEBUG : remove from docInDatabase<br />\n";
		  unset($docInDataBase[$alreadyPresent]);
		    if (sizeString($entry) != $docSize[$alreadyPresent])
		      {
			// echo "DEBUG : update size<br />\n";
			sqlQuery("UPDATE docs SET ".sizeString($entry)." WHERE id='$alreadyPresent'");
		      }
		  }
		else
		  {
		    echo "  $msg : Adding $entry[source] in database<br />\n";
		    sqlQuery("INSERT INTO docs SET ".sourceString($entry).", ".sizeString($entry));
		    sqlQuery("INSERT INTO publidocs SET idPubli=$publiId, idDoc=".mysql_insert_id());
		  }
	      }
	  }
      }
  $dir->close();

  // Remove unused documents
  foreach(array_keys($docInDataBase) as $docId)
    {
      // Delete these documents
      $src = ereg_replace(".*source='([^']*).*", "\\1", $docInDataBase["$docId"]);
      $type = ereg_replace(".*type='([^']*).*", "\\1", $docInDataBase["$docId"]);
      echo "  $msg : Removing $src from database<br />\n";
      if (($type=="MOV") || ($type=="IMG"))
	{
	  if (!is_file("$publiPath/$thumbDir/$src.jpg"))
	    sendMessage("Cannot remove $msgPath/$thumbDir/$src.jpg : it doesn't exist !");
	  else
	    {
	      @system("rm $publiPath/$thumbDir/$src.jpg", $retVal);
	      if ($retVal != 0)
		sendMessage("Unable to remove $msgPath/$thumbDir/$src.jpg");
	    }
	}
      sqlQuery("DELETE FROM docs WHERE id=$docId");
      sqlQuery("DELETE FROM publidocs WHERE idDoc=$docId");
    }
}

?>
